/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.ldt.bills.controller;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springblade.common.aop.core.TenantAop;
import org.springblade.common.constant.Salesman;
import org.springblade.common.utils.ExcelWriteUtil;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.ldt.bills.entity.TransferRec;
import org.springblade.ldt.bills.service.ITransferRecService;
import org.springblade.ldt.bills.vo.TransferRecVO;
import org.springblade.ldt.bills.wrapper.TransferRecWrapper;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.Date;
import java.util.Map;

/**
 * 转账记录表 控制器
 *
 * @author BladeX
 * @since 2021-11-02
 */
@RestController
@AllArgsConstructor
@RequestMapping("ldt_bills/transferrec")
@Api(value = "转账记录表", tags = "转账记录表接口")
@Slf4j
public class TransferRecController extends BladeController {

	private final ITransferRecService transferRecService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入transferRec")
	public R<TransferRecVO> detail(TransferRec transferRec) {
		TransferRec detail = transferRecService.getOne(Condition.getQueryWrapper(transferRec));
		return R.data(TransferRecWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 转账记录表
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入transferRec")
	public R<IPage<TransferRecVO>> list(TransferRec transferRec, Query query, Date createTimeStart, Date createTimeEnd, String key) {
		QueryWrapper<TransferRec> queryWrapper = Condition.getQueryWrapper(transferRec);
		//添加创建时间条件
		if (createTimeStart != null && createTimeEnd != null) {
			queryWrapper.lambda().between(TransferRec::getCreateTime, createTimeStart, createTimeEnd);
		}
		//添加关键字key查询条件
		if (StringUtils.isNotBlank(key)) {
			queryWrapper.lambda().and(wq -> {
				wq.eq(TransferRec::getId, key);
			});
		}
		//循环查询
		return R.data(TransferRecWrapper.build().pageVO(transferRecService.page(Condition.getPage(query), queryWrapper)));
	}

	/**
	 * 生成列表
	 */
	@PostMapping("/generateList")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "生成列表", notes = "传入withdrawRec")
	@TenantAop(salesman = Salesman.roleName)
	public void generateList(TransferRec transferRec, Query query, Date createTimeStart, Date createTimeEnd,
							 String key,
							 @RequestParam String keyValue,
							 HttpServletResponse response) {
		try {
			R<IPage<TransferRecVO>> page = this.list(transferRec, query, createTimeStart, createTimeEnd, key);
			//判断是否为空
			if (ObjectUtils.isNotEmpty(page) && ObjectUtils.isNotEmpty(page.getData()) && ObjectUtils.isNotEmpty(page.getData().getRecords())) {
				//键值对
				Map<String, String> titleMap = JSONObject.parseObject(keyValue, Map.class);
				if (ObjectUtils.isNotEmpty(titleMap)) {
					//写入到Excel
					ExcelWriteUtil.writeToResponse(response, DateUtil.now(), "提现记录表", titleMap, page.getData().getRecords(), TransferRecVO.class);
					return;
				}
			}
		} catch (Exception e) {
			log.error(e.getMessage());
		}
	}

	/**
	 * 自定义分页 转账记录表
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入transferRec")
	public R<IPage<TransferRecVO>> page(TransferRecVO transferRec, Query query) {
		IPage<TransferRecVO> pages = transferRecService.selectTransferRecPage(Condition.getPage(query), transferRec);
		return R.data(pages);
	}

	/**
	 * 新增 转账记录表
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入transferRec")
	public R save(@Valid @RequestBody TransferRec transferRec) {
		return R.status(transferRecService.save(transferRec));
	}

	/**
	 * 修改 转账记录表
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入transferRec")
	public R update(@Valid @RequestBody TransferRec transferRec) {
		return R.status(transferRecService.updateById(transferRec));
	}

	/**
	 * 新增或修改 转账记录表
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入transferRec")
	public R submit(@Valid @RequestBody TransferRec transferRec) {
		return R.status(transferRecService.saveOrUpdate(transferRec));
	}


	/**
	 * 删除 转账记录表
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(transferRecService.deleteLogic(Func.toLongList(ids)));
	}


}
